// --------------------------------------------------------------------------------------------
//
//		Sudo for Windows Version 1.0	2005/11
//		Sudo for Windows Version 1.1	2006/10
//
//		Runs a program or opens a document with admin rights in the context of
//		the current user account.
//		Copyright (c) 2006 by R. Tchorz
//
// --------------------------------------------------------------------------------------------
#define UNICODE
#include <windows.h>
#include <lmaccess.h>
#include <lmapibuf.h>
#include <lmerr.h>
#include "sudo.rh"
// -----  Borland C++ stuff ----------
#if(__BORLANDC__ > 0x500)
#include <condefs.h>
	USELIB("advapi32.lib");
	USELIB("msvcrt.lib");	// to reduce the size of the exe-file
	USELIB("noeh32.lib");
	USERC("Sudo.RC");
#endif
//---------------------------------------------------------------------------

// Older compiler may need this
extern "C" WINAPI BOOL CreateProcessWithLogonW(
  LPCWSTR lpUsername,
  LPCWSTR lpDomain,
  LPCWSTR lpPassword,
  DWORD dwLogonFlags,
  LPCWSTR lpApplicationName,
  LPWSTR lpCommandLine,
  DWORD dwCreationFlags,
  LPVOID lpEnvironment,
  LPCWSTR lpCurrentDirectory,
  LPSTARTUPINFOW lpStartupInfo,
  LPPROCESS_INFORMATION lpProcessInfo
);


#define NUM_C(str)		(sizeof(str)/sizeof(str[0]))



bool bSecond;				// is true, if the second instance was started.
bool bLikeRunAs;
bool bUserIsOwner;			// when true, new files owns current user.
TCHAR user_name[32], user_pwd[32];
TCHAR admin_name[32], admin_pwd[32];




const TCHAR *loadStr(unsigned id, TCHAR *txt, unsigned nSize)
{
	LoadString(NULL,id,txt,nSize);
	return txt;
}



void errorBox(DWORD idUser, DWORD idSystem)
{
TCHAR title[32];
TCHAR txt[512];

	if (idSystem)
		if (FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,NULL,idSystem,0,txt,NUM_C(txt),NULL)==0)
			idUser = sUnknownErr;
	if (idUser)
		loadStr(idUser,txt,NUM_C(txt));
	MessageBox(NULL,txt,loadStr(sTitle,title,NUM_C(title)),MB_ICONERROR|MB_OK);
}


//-----------------------------------------------------------------------------
//	This stuff has to do with user and user groups...


// Search for the local user group of the administrators.
// The name of this group is country-specific.
bool getAdminGroup(TCHAR *admins)
{
DWORD nread, total, i;
DWORD sdomaene;
LOCALGROUP_INFO_0 *info;
BYTE sid[192];
SID_NAME_USE seUse;
TCHAR domaene[128];
PSID psidAdministrators;
bool res = false;
SID_IDENTIFIER_AUTHORITY siaNtAuthority = {SECURITY_NT_AUTHORITY};

	AllocateAndInitializeSid(&siaNtAuthority,2,SECURITY_BUILTIN_DOMAIN_RID,
			  DOMAIN_ALIAS_RID_ADMINS, 0, 0, 0, 0, 0, 0,&psidAdministrators);
	i = 0;
	if ( NetLocalGroupEnum(NULL,0,(BYTE**)&info,16*1024,&nread,&total,&i) == NERR_Success )
	{
		for(i=0; i<nread; i++)
		{
			total = sizeof(sid);
			sdomaene = 128;
			LookupAccountName(NULL,info[i].lgrpi0_name,&sid,&total,domaene,&sdomaene,&seUse);
			if ( EqualSid(psidAdministrators, sid) )
			{
				lstrcpy(admins,info[i].lgrpi0_name);
				res = true;
				break;
			}
		}
		NetApiBufferFree(info);
	}
	else
		errorBox(sAdminGroup,0);
	FreeSid(psidAdministrators);
	return res;
}


// List the available administrators in a Combo-box
void getListOfAdmins(HWND hList)
{
DWORD nread, total, i;
USER_INFO_1 *info;

	i = 0;
	if (NetUserEnum(NULL,1,FILTER_NORMAL_ACCOUNT,(BYTE**)&info,16*124,&nread,&total,&i) == NERR_Success)
	{
		for(i=0; i<nread; i++)
			if ( info[i].usri1_priv == USER_PRIV_ADMIN)
				SendMessage(hList,CB_ADDSTRING,0,long(info[i].usri1_name));
		NetApiBufferFree(info);
	}
	if (SendMessage(hList,CB_SELECTSTRING,0,long(admin_name)) == CB_ERR)
		SendMessage(hList,CB_SETCURSEL,0,0);
}



bool isUserAdmin(void)
{
HANDLE hAccessToken;
UCHAR InfoBuffer[1024];
PTOKEN_GROUPS ptgGroups = (PTOKEN_GROUPS)InfoBuffer;
DWORD dwInfoBufferSize;
PSID psidAdministrators;
SID_IDENTIFIER_AUTHORITY siaNtAuthority = {SECURITY_NT_AUTHORITY};
unsigned x;
bool res = false;

	if( OpenProcessToken(GetCurrentProcess(),TOKEN_READ,&hAccessToken) &&
		GetTokenInformation(hAccessToken,TokenGroups,InfoBuffer,1024,&dwInfoBufferSize) )
	{
		AllocateAndInitializeSid(&siaNtAuthority,2,SECURITY_BUILTIN_DOMAIN_RID,DOMAIN_ALIAS_RID_ADMINS,
						0,0,0,0,0,0,&psidAdministrators);
		for(x=0; x<ptgGroups->GroupCount; x++)
			if( EqualSid(psidAdministrators, ptgGroups->Groups[x].Sid) )
			{
				res = true;
				break;
			}
	}
	FreeSid(psidAdministrators);
	return res;
}


// ------------------------------------------------------------------------------------------
// Writing and reading of the config from the registery.
// The dates are encoded stored.


#pragma pack(push, 2)	// 2-Byte alignment

typedef struct {
	WORD dataLen, keyLen;
	BYTE data[2048];
} sCfg;

#pragma pack(pop)


void saveCfg()
{
int l;
HCRYPTPROV hProv;
HCRYPTKEY hXchgKey, hKey;
DWORD dwIndex;
HKEY hRegKey;
sCfg cfg;

	if (RegCreateKey(HKEY_CURRENT_USER,TEXT("Software\\Sudo"),&hRegKey) != ERROR_SUCCESS)
		return;
	if ( CryptAcquireContext(&hProv,NULL,NULL,PROV_RSA_FULL,0))
	{
		if (CryptGetUserKey(hProv,AT_KEYEXCHANGE,&hXchgKey))
		{
			CryptGenKey(hProv,CALG_RC2,CRYPT_EXPORTABLE,&hKey);
			dwIndex = 1024;
			CryptExportKey(hKey,hXchgKey,SIMPLEBLOB,0,cfg.data,&dwIndex);
			cfg.keyLen = WORD(dwIndex);

			CopyMemory(&cfg.data[dwIndex],user_pwd,l=(lstrlen(user_pwd)+1)*2);
			dwIndex += l;
			CopyMemory(&cfg.data[dwIndex],admin_name,l=(lstrlen(admin_name)+1)*2);
			dwIndex += l;
			CopyMemory(&cfg.data[dwIndex],admin_pwd,l=(lstrlen(admin_pwd)+1)*2);
			dwIndex += l;

			dwIndex -= cfg.keyLen; // size
			CryptEncrypt(hKey,0,TRUE,0,(BYTE*)&cfg.data[cfg.keyLen],&dwIndex,2048);
			cfg.dataLen = WORD(dwIndex); // encoded size

			CryptDestroyKey(hKey);
			CryptDestroyKey(hXchgKey);
		}
		CryptReleaseContext(hProv,0);
		RegSetValueEx(hRegKey,TEXT("V"),0,REG_BINARY,(BYTE*)&cfg,dwIndex+cfg.keyLen+4);
	}
	RegCloseKey(hRegKey);
}



TCHAR *readCfgWord(TCHAR *pData, TCHAR *pWord)
{
	while ( *pData != 0 )
	{
		*pWord = *pData;
		pWord++;
		pData++;
	};
	*pWord = 0;
	return pData + 1;
}



void readCfg()
{
HKEY hRegKey;
DWORD dwSize;
HCRYPTPROV hProv;
HCRYPTKEY hKey;
TCHAR word[32], *p;
sCfg cfg;

	if ( RegOpenKey(HKEY_CURRENT_USER,TEXT("Software\\Sudo"),&hRegKey) == ERROR_SUCCESS )
	{
		dwSize = sizeof(cfg);
		RegQueryValueEx(hRegKey,TEXT("V"),0,NULL,(BYTE*)&cfg,&dwSize);
		if ( CryptAcquireContext(&hProv,NULL,NULL,PROV_RSA_FULL,0))
		{
			if (CryptImportKey(hProv,cfg.data,cfg.keyLen,0,0,&hKey))
			{
				dwSize = cfg.dataLen;
				if (CryptDecrypt(hKey,0,TRUE,0,&cfg.data[cfg.keyLen],&dwSize))
				{
					p = (TCHAR*)&cfg.data[cfg.keyLen];
					p = readCfgWord(p,word);
					if (user_pwd[0] == 0)
						lstrcpyW(user_pwd,word);
					p = readCfgWord(p,word);
					if (admin_name[0] == 0)
						lstrcpyW(admin_name,word);
					readCfgWord(p,word);
					if (admin_pwd[0] == 0)
						lstrcpyW(admin_pwd,word);
				}
				CryptDestroyKey(hKey);
			}
			CryptReleaseContext(hProv,0);
		}
		RegCloseKey(hRegKey);
	}
}


// ------------------------------------------------------------------------------------------
//The dialog box, in order to configure Sudo or to ask missing dates.

BOOL CALLBACK DialogProc(HWND hDlg, UINT uMsg,WPARAM wP, LPARAM lP)
{
static bool bConf;

	switch(uMsg)
	{
		case WM_COMMAND:
			switch ( LOWORD(wP) )
			{
				case IDCANCEL:
					EndDialog(hDlg,IDCANCEL);
					break;
				case IDOK:
					if (user_pwd[0] == 0)
						GetDlgItemText(hDlg,idUserPwd,user_pwd,NUM_C(user_pwd));
					if (admin_pwd[0] == 0)
						GetDlgItemText(hDlg,idAdminPwd,admin_pwd,NUM_C(admin_pwd));
					if (admin_name[0] == 0)
						GetDlgItemText(hDlg,idAdminList,admin_name,NUM_C(admin_name));
					if (bConf)
						saveCfg();
					EndDialog(hDlg,IDOK);
					break;
				case idSave:
					SendMessage(hDlg,WM_COMMAND,IDOK,0);
					saveCfg();
					break;
				case idDelCfg:
					RegDeleteKey(HKEY_CURRENT_USER,TEXT("Software\\Sudo"));
					EnableWindow(GetDlgItem(hDlg,idDelCfg),FALSE);
					EnableWindow(GetDlgItem(hDlg,idUserPwd),TRUE);
					EnableWindow(GetDlgItem(hDlg,idAdminPwd),TRUE);
					EnableWindow(GetDlgItem(hDlg,idAdminList),TRUE);
					user_pwd[0] = admin_pwd[0] = admin_name[0] = 0;
					break;
			}
			break;
		case WM_INITDIALOG:
			{
			HKEY hKey=NULL;
				bConf = bool(lP);
				if (!lP) // If this is true, sudo is configured.
				{
					EnableWindow(GetDlgItem(hDlg,idUserPwd),user_pwd[0] == 0 && !bLikeRunAs);
					EnableWindow(GetDlgItem(hDlg,idAdminPwd),admin_pwd[0] == 0);
					EnableWindow(GetDlgItem(hDlg,idAdminList),admin_name[0] == 0);
				}
				if (RegOpenKey(HKEY_CURRENT_USER,TEXT("Software\\Sudo"),&hKey) != ERROR_SUCCESS)
					EnableWindow(GetDlgItem(hDlg,idDelCfg),FALSE);
				RegCloseKey(hKey);
				getListOfAdmins(GetDlgItem(hDlg,idAdminList));
			}
			break;
	}
	return FALSE;
}


bool configSudo(bool bConfig)
{
	if (!bConfig)
		readCfg();
	return DialogBoxParam(NULL,MAKEINTRESOURCE(100),NULL,DialogProc,bConfig) == IDOK;
}

// ------------------------------------------------------------------------------------------


//	Runs a program or opens a document into another user context.
void runAs(TCHAR *pUser, TCHAR *pPwd, TCHAR *pCommand)
{
int argc;
TCHAR *pNewCommand, **argv;
TCHAR cur_dir[MAX_PATH], exe[MAX_PATH];
PROCESS_INFORMATION pi;
STARTUPINFOW si;

	GetCurrentDirectory(MAX_PATH,cur_dir);
	if ( (argv = CommandLineToArgvW(pCommand,&argc)) != NULL )
	{
		if ( SearchPath(NULL,argv[0],NULL,MAX_PATH,exe,NULL) && !GetBinaryType(exe,(DWORD*)&argc) )
			if ((int)FindExecutable(argv[0],NULL,exe) > 32)
			{
				pNewCommand = (TCHAR*)malloc((lstrlen(exe)+lstrlen(pCommand) + 2)*sizeof(exe[0]));
				lstrcpy(pNewCommand,exe);
				lstrcat(lstrcat(pNewCommand,TEXT(" ")),pCommand);
				pCommand = pNewCommand;
			}
		GlobalFree(argv);
	}
	ZeroMemory(&si,sizeof(si));
	si.cb = sizeof(si);
	if (CreateProcessWithLogonW(pUser,TEXT("."),pPwd,1,NULL,pCommand,0,NULL,cur_dir,&si,&pi))
	{
		WaitForInputIdle(pi.hProcess,2*1000); // Wait until the program started.
		CloseHandle(pi.hThread);
		CloseHandle(pi.hProcess);
	}
	else
		errorBox(0,GetLastError());
}


// Sudo is started to the second once.
// The current user to the local user group of the administrators add,
// starting the program and removing the user from this group.
void secondInstance(TCHAR *pCmd)
{
TCHAR user[64], admins[64];
LOCALGROUP_MEMBERS_INFO_3 info;
HKEY hKey;
DWORD dwSize,dwDefOwner = 0, dwNewVal = 0;

	if (getAdminGroup(admins))
	{
		lstrcat(lstrcpy(user,TEXT("\\")),user_name);
		info.lgrmi3_domainandname = user;
		if ( NetLocalGroupAddMembers(NULL,admins,3,(BYTE*)&info,1) == NERR_Success )
		{
			RegOpenKey(HKEY_LOCAL_MACHINE,TEXT("SYSTEM\\CurrentControlSet\\Control\\Lsa"),&hKey);
			if (bUserIsOwner)
				dwNewVal = 1;
			dwSize = sizeof(dwDefOwner);
			if (RegQueryValueEx(hKey,TEXT("nodefaultadminowner"),0,NULL,(BYTE*)&dwDefOwner,&dwSize)==ERROR_SUCCESS)
				if (dwDefOwner != dwNewVal)
					RegSetValueEx(hKey,TEXT("nodefaultadminowner"),0,REG_DWORD,(BYTE*)&dwNewVal,sizeof(dwNewVal));
			runAs(user,user_pwd,pCmd);
			NetLocalGroupDelMembers(NULL,admins,3,(BYTE*)&info,1);
			if (dwDefOwner != dwNewVal)
				RegSetValueEx(hKey,TEXT("nodefaultadminowner"),0,REG_DWORD,(BYTE*)&dwDefOwner,sizeof(dwDefOwner));
			RegCloseKey(hKey);
		}
		else
			errorBox(0,GetLastError());
	}
}


// ------------------------------------------------------------------------------------------

TCHAR *getWord(TCHAR *pCmd, TCHAR *pWord, unsigned size)
{
unsigned c = 0;

	pCmd++;
	while ( *pCmd  &&  *pCmd != ' ' && c<size-1)
	{
		*pWord = *pCmd;
		pWord++;
		pCmd++;
		c++;
	}
	*pWord = 0;
	return pCmd;
}


// Returns NULL when errors occurs
TCHAR *parseCommandLine(TCHAR *pCmd)
{
	if ( (pCmd = wcschr(pCmd,' ')) != NULL )
		while( *pCmd != 0 )
		{
			switch(*pCmd)
			{
				case ' ':
					pCmd++;
					break;
				case '-':
					pCmd++;
					switch(*pCmd)
					{
						case '\n':
							pCmd = getWord(pCmd,user_name,NUM_C(user_name));
							bSecond = true;
							break;
						case 'p':
							pCmd = getWord(pCmd,user_pwd,NUM_C(user_pwd));
							break;
						case 'n':
							pCmd = getWord(pCmd,admin_name,NUM_C(admin_name));
							break;
						case 'a':
							pCmd = getWord(pCmd,admin_pwd,NUM_C(admin_pwd));
							break;
						case 'r':
							bLikeRunAs = true;
							pCmd++;
							break;
						case 'o':
							bUserIsOwner = true;
							pCmd++;
							break;
						case 'c':
							configSudo(true);
							exit(0);
							break;
						default:
							return NULL;
					}
					break;
				default:
					return pCmd;
			}
	}
	return NULL;
}



WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
TCHAR *pCmd;
TCHAR parm[1024];
DWORD nSize;

	if ( (pCmd = parseCommandLine(GetCommandLine())) != NULL )
	{
		if (bSecond)
			secondInstance(pCmd);
		else
		{
// The first instance
// Creates a second instance in the admin-context with the user name as parameters.

			if (!isUserAdmin())
			{
				if ( (user_pwd[0]==0 && !bLikeRunAs) || admin_pwd[0]==0 || admin_name[0]==0 )
					readCfg();
				if ( (user_pwd[0]==0 && !bLikeRunAs) || admin_pwd[0]==0 || admin_name[0]==0 )
					if (!configSudo(false))
						return 0;
				if (bLikeRunAs)
				{
					runAs(admin_name,admin_pwd,pCmd);
					return 0;
				}
				GetModuleFileName(NULL,parm,NUM_C(parm));
				nSize = NUM_C(user_name);
				GetUserName(user_name,&nSize);
				wsprintf(&parm[lstrlen(parm)],TEXT(" -\n%s -p%s "),user_name,user_pwd);
				if (bUserIsOwner)
					lstrcat(parm,TEXT("-o "));
				lstrcat(parm,pCmd);
				runAs(admin_name,admin_pwd,parm);
			}
			else
				errorBox(sAdmin,0);
		}
	}
	else
		MessageBox(NULL,loadStr(sUsage,parm,NUM_C(parm)),
				loadStr(sTitle,user_name,NUM_C(user_name)),MB_ICONINFORMATION|MB_OK);
	return 0;
}
